=== debian/changelog ===
mame (0.206+dfsg.1-0.1~mx17+1) mx; urgency=medium

  * Rebuild for MX 17.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 02 Feb 2019 21:08:37 -0800

mame (0.206+dfsg.1-0ubuntu1~ppa1~bionic1) bionic; urgency=medium

  * New upstream release.
  * Refresh patches.

 -- Cesare Falco <c.falco@ubuntu.com>  Thu, 27 Dec 2018 11:17:41 +0100

mame (0.205+dfsg.1-0ubuntu1~ppa2~cosmic1) cosmic; urgency=medium

  * New upstream release.

 -- Cesare Falco <c.falco@ubuntu.com>  Thu, 27 Dec 2018 11:17:41 +0100

mame (0.198+dfsg.1-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Fix option to use gold linker.
  * Accept warning for multiple entry in armhf linking options.

 -- Cesare Falco <c.falco@ubuntu.com>  Wed, 30 May 2018 15:33:13 +0200

mame (0.197+dfsg.1-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Updated patches:
    - removed fix_c_fallback.patch, accepted upstream
    - refreshed hurd.patch

 -- Cesare Falco <c.falco@ubuntu.com>  Wed, 25 Apr 2018 12:30:00 +0200

mame (0.196-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Update Vcs-* fields to reflect migration to salsa.debian.org.

 -- Jordi Mallach <jordi@debian.org>  Fri, 30 Mar 2018 01:40:54 +0200
